package org.framework.lazy.cloud.network.heartbeat.server.standalone.domain.model.lazy.netty.server.permeate.client.mapping;

import org.wu.framework.lazy.orm.database.lambda.domain.LazyPage;
import org.wu.framework.web.response.Result;
import org.wu.framework.lazy.orm.core.persistence.reverse.lazy.ddd.DefaultDDDLazyDomainRepository;

import java.util.List;

/**
 * describe 内网穿透映射
 *
 * @author Jia wei Wu
 * @date 2023/12/29 05:21 下午
 * @see DefaultDDDLazyDomainRepository
 **/

public interface LazyInternalNetworkServerPermeateClientMappingRepository {


    /**
     * describe 新增内网穿透映射
     *
     * @param lazyInternalNetworkServerPermeateClientMapping 新增内网穿透映射
     * @return {@link  Result<  LazyInternalNetworkServerPermeateClientMapping  >} 内网穿透映射新增后领域对象
     * @author Jia wei Wu
     * @date 2023/12/29 05:21 下午
     **/

    Result<LazyInternalNetworkServerPermeateClientMapping> story(LazyInternalNetworkServerPermeateClientMapping lazyInternalNetworkServerPermeateClientMapping);

    /**
     * describe 批量新增内网穿透映射
     *
     * @param lazyInternalNetworkServerPermeateClientMappingList 批量新增内网穿透映射
     * @return {@link Result<List<  LazyInternalNetworkServerPermeateClientMapping  >>} 内网穿透映射新增后领域对象集合
     * @author Jia wei Wu
     * @date 2023/12/29 05:21 下午
     **/

    Result<List<LazyInternalNetworkServerPermeateClientMapping>> batchStory(List<LazyInternalNetworkServerPermeateClientMapping> lazyInternalNetworkServerPermeateClientMappingList);

    /**
     * describe 查询单个内网穿透映射
     *
     * @param lazyInternalNetworkServerPermeateClientMapping 查询单个内网穿透映射
     * @return {@link Result<  LazyInternalNetworkServerPermeateClientMapping  >} 内网穿透映射DTO对象
     * @author Jia wei Wu
     * @date 2023/12/29 05:21 下午
     **/

    Result<LazyInternalNetworkServerPermeateClientMapping> findOne(LazyInternalNetworkServerPermeateClientMapping lazyInternalNetworkServerPermeateClientMapping);

    /**
     * describe 查询多个内网穿透映射
     *
     * @param lazyInternalNetworkServerPermeateClientMapping 查询多个内网穿透映射
     * @return {@link Result<List<  LazyInternalNetworkServerPermeateClientMapping  >>} 内网穿透映射DTO对象
     * @author Jia wei Wu
     * @date 2023/12/29 05:21 下午
     **/

    Result<List<LazyInternalNetworkServerPermeateClientMapping>> findList(LazyInternalNetworkServerPermeateClientMapping lazyInternalNetworkServerPermeateClientMapping);

    /**
     * describe 分页查询多个内网穿透映射
     *
     * @param size                              当前页数
     * @param current                           当前页
     * @param lazyInternalNetworkServerPermeateClientMapping 分页查询多个内网穿透映射
     * @return {@link Result<LazyPage<  LazyInternalNetworkServerPermeateClientMapping  >>} 分页内网穿透映射领域对象
     * @author Jia wei Wu
     * @date 2023/12/29 05:21 下午
     **/

    Result<LazyPage<LazyInternalNetworkServerPermeateClientMapping>> findPage(int size, int current, LazyInternalNetworkServerPermeateClientMapping lazyInternalNetworkServerPermeateClientMapping);

    /**
     * describe 删除内网穿透映射
     *
     * @param lazyInternalNetworkServerPermeateClientMapping 删除内网穿透映射
     * @return {@link Result<   LazyInternalNetworkServerPermeateClientMapping   >} 内网穿透映射
     * @author Jia wei Wu
     * @date 2023/12/29 05:21 下午
     **/

    Result<LazyInternalNetworkServerPermeateClientMapping> remove(LazyInternalNetworkServerPermeateClientMapping lazyInternalNetworkServerPermeateClientMapping);

    /**
     * describe 是否存在内网穿透映射
     *
     * @param lazyInternalNetworkServerPermeateClientMapping 是否存在内网穿透映射
     * @return {@link Result<Boolean>} 内网穿透映射是否存在
     * @author Jia wei Wu
     * @date 2023/12/29 05:21 下午
     **/

    Result<Boolean> exists(LazyInternalNetworkServerPermeateClientMapping lazyInternalNetworkServerPermeateClientMapping);

}