package org.framework.lazy.cloud.network.heartbeat.server.standalone.domain.model.lazy.netty.server.permeate.server.mapping;

import org.wu.framework.web.response.Result;

import java.util.List;
import org.wu.framework.lazy.orm.database.lambda.domain.LazyPage;
/**
 * describe 服务端网络渗透映射 
 *
 * @author Jia wei Wu
 * @date 2024/09/17 01:35 下午
 * @see org.wu.framework.lazy.orm.core.persistence.reverse.lazy.ddd.DefaultDDDLazyDomainRepository 
 **/

public interface LazyInternalNetworkServerPermeateServerMappingRepository {


    /**
     * describe 新增服务端网络渗透映射
     *
     * @param lazyInternalNetworkServerPermeateServerMapping 新增服务端网络渗透映射
     * @return {@link  Result< LazyInternalNetworkServerPermeateServerMapping >} 服务端网络渗透映射新增后领域对象
     
     * @author Jia wei Wu
     * @date 2024/09/17 01:35 下午
     **/

    Result<LazyInternalNetworkServerPermeateServerMapping> story(LazyInternalNetworkServerPermeateServerMapping lazyInternalNetworkServerPermeateServerMapping);

    /**
     * describe 批量新增服务端网络渗透映射
     *
     * @param lazyInternalNetworkServerPermeateServerMappingList 批量新增服务端网络渗透映射
     * @return {@link Result<List< LazyInternalNetworkServerPermeateServerMapping >>} 服务端网络渗透映射新增后领域对象集合
     
     * @author Jia wei Wu
     * @date 2024/09/17 01:35 下午
     **/

    Result<List<LazyInternalNetworkServerPermeateServerMapping>> batchStory(List<LazyInternalNetworkServerPermeateServerMapping> lazyInternalNetworkServerPermeateServerMappingList);

    /**
     * describe 查询单个服务端网络渗透映射
     *
     * @param lazyInternalNetworkServerPermeateServerMapping 查询单个服务端网络渗透映射
     * @return {@link Result< LazyInternalNetworkServerPermeateServerMapping >} 服务端网络渗透映射DTO对象
     
     * @author Jia wei Wu
     * @date 2024/09/17 01:35 下午
     **/

    Result<LazyInternalNetworkServerPermeateServerMapping> findOne(LazyInternalNetworkServerPermeateServerMapping lazyInternalNetworkServerPermeateServerMapping);

    /**
     * describe 查询多个服务端网络渗透映射
     *
     * @param lazyInternalNetworkServerPermeateServerMapping 查询多个服务端网络渗透映射
     * @return {@link Result<List< LazyInternalNetworkServerPermeateServerMapping >>} 服务端网络渗透映射DTO对象
     
     * @author Jia wei Wu
     * @date 2024/09/17 01:35 下午
     **/

    Result<List<LazyInternalNetworkServerPermeateServerMapping>> findList(LazyInternalNetworkServerPermeateServerMapping lazyInternalNetworkServerPermeateServerMapping);

    /**
     * describe 分页查询多个服务端网络渗透映射
     *
     * @param size 当前页数
     * @param current 当前页
     * @param lazyInternalNetworkServerPermeateServerMapping 分页查询多个服务端网络渗透映射
     * @return {@link Result<LazyPage< LazyInternalNetworkServerPermeateServerMapping >>} 分页服务端网络渗透映射领域对象
     
     * @author Jia wei Wu
     * @date 2024/09/17 01:35 下午
     **/

    Result<LazyPage<LazyInternalNetworkServerPermeateServerMapping>> findPage(int size, int current, LazyInternalNetworkServerPermeateServerMapping lazyInternalNetworkServerPermeateServerMapping);

    /**
     * describe 删除服务端网络渗透映射
     *
     * @param lazyInternalNetworkServerPermeateServerMapping 删除服务端网络渗透映射
     * @return {@link Result< LazyInternalNetworkServerPermeateServerMapping >} 服务端网络渗透映射
     
     * @author Jia wei Wu
     * @date 2024/09/17 01:35 下午
     **/

    Result<LazyInternalNetworkServerPermeateServerMapping> remove(LazyInternalNetworkServerPermeateServerMapping lazyInternalNetworkServerPermeateServerMapping);

    /**
     * describe 是否存在服务端网络渗透映射
     *
     * @param lazyInternalNetworkServerPermeateServerMapping 是否存在服务端网络渗透映射
     * @return {@link Result<Boolean>} 服务端网络渗透映射是否存在     
     
     * @author Jia wei Wu
     * @date 2024/09/17 01:35 下午
     **/

    Result<Boolean> exists(LazyInternalNetworkServerPermeateServerMapping lazyInternalNetworkServerPermeateServerMapping);

}